org.apache.xerces.parsers

## Class SecureProcessingConfiguration

- java.lang.Object
- - org.apache.xerces.util.ParserConfigurationSettings
  - - org.apache.xerces.parsers.XML11Configuration
    - - org.apache.xerces.parsers.XIncludeAwareParserConfiguration
      - - org.apache.xerces.parsers.SecureProcessingConfiguration

- All Implemented Interfaces:
    XML11Configurable, org.apache.xerces.xni.parser.XMLComponentManager, org.apache.xerces.xni.parser.XMLParserConfiguration, org.apache.xerces.xni.parser.XMLPullParserConfiguration

      public final class SecureProcessingConfiguration
      extends XIncludeAwareParserConfiguration

  This configuration enhances Xerces support for the JAXP secure processing feature.
  Version:
    $Id: SecureProcessingConfiguration.java 1718452 2015-12-07 20:17:51Z mrglavas $
  Author:
    Michael Glavassevich, IBM

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `ENTITY_EXPANSION_LIMIT_SYSTEM_VALUE`
    `protected int` | `MAX_GENERAL_ENTITY_SIZE_LIMIT_SYSTEM_VALUE`
    `protected int` | `MAX_OCCUR_LIMIT_SYSTEM_VALUE`
    `protected int` | `MAX_PARAMETER_ENTITY_SIZE_LIMIT_SYSTEM_VALUE`
    `protected boolean` | `RESOLVE_EXTERNAL_ENTITIES_SYSTEM_VALUE`
    `protected int` | `TOTAL_ENTITY_SIZE_LIMIT_SYSTEM_VALUE`

    - ### Fields inherited from class org.apache.xerces.parsers.XIncludeAwareParserConfiguration

      `ALLOW_UE_AND_NOTATION_EVENTS, fCurrentNSContext, fNonXIncludeNSContext, fXIncludeEnabled, fXIncludeHandler, fXIncludeNSContext, NAMESPACE_CONTEXT, XINCLUDE_FEATURE, XINCLUDE_FIXUP_BASE_URIS, XINCLUDE_FIXUP_LANGUAGE, XINCLUDE_HANDLER`

    - ### Fields inherited from class org.apache.xerces.parsers.XML11Configuration

      `ALLOW_JAVA_ENCODINGS, ASSERT_COMMENT_PI_CHECKING, CONTINUE_AFTER_FATAL_ERROR, CTA_FULL_XPATH_CHECKING, DATATYPE_VALIDATOR_FACTORY, DOCUMENT_SCANNER, DTD_PROCESSOR, DTD_SCANNER, DTD_VALIDATOR, ENTITY_MANAGER, ENTITY_RESOLVER, ERROR_HANDLER, ERROR_REPORTER, fCommonComponents, fComponents, fConfigUpdated, fCurrentDTDScanner, fCurrentDVFactory, fCurrentScanner, fDatatypeValidatorFactory, fDocumentHandler, fDTDContentModelHandler, fDTDHandler, fDTDProcessor, fDTDScanner, fDTDValidator, fEntityManager, fErrorReporter, fGrammarPool, fInputSource, fLastComponent, fLocale, fNamespaceScanner, fNonNSDTDValidator, fNonNSScanner, fParseInProgress, fSchemaValidator, fSymbolTable, fValidationManager, fVersionDetector, fXML11Components, fXML11DatatypeFactory, fXML11DocScanner, fXML11DTDProcessor, fXML11DTDScanner, fXML11DTDValidator, fXML11NSDocScanner, fXML11NSDTDValidator, GENERATE_SYNTHETIC_ANNOTATIONS, HONOUR_ALL_SCHEMALOCATIONS, ID_IDREF_CHECKING, IDENTITY_CONSTRAINT_CHECKING, IGNORE_XSI_TYPE, JAXP_SCHEMA_LANGUAGE, JAXP_SCHEMA_SOURCE, LOCALE, NAMESPACE_BINDER, NAMESPACE_GROWTH, NAMESPACES, NORMALIZE_DATA, NOTIFY_BUILTIN_REFS, NOTIFY_CHAR_REFS, PRINT_EXCEPTION_STACK_TRACE, ROOT_ELEMENT_DECL, ROOT_TYPE_DEF, SCHEMA_AUGMENT_PSVI, SCHEMA_DV_FACTORY, SCHEMA_ELEMENT_DEFAULT, SCHEMA_LOCATION, SCHEMA_NONS_LOCATION, SCHEMA_VALIDATOR, SYMBOL_TABLE, TOLERATE_DUPLICATES, TYPE_ALTERNATIVES_CHECKING, UNPARSED_ENTITY_CHECKING, USE_GRAMMAR_POOL_ONLY, VALIDATE_ANNOTATIONS, VALIDATION, VALIDATION_MANAGER, WARN_ON_DUPLICATE_ATTDEF, WARN_ON_DUPLICATE_ENTITYDEF, WARN_ON_UNDECLARED_ELEMDEF, XML_STRING, XML11_DATATYPE_VALIDATOR_FACTORY, XMLGRAMMAR_POOL, XMLSCHEMA_FULL_CHECKING, XMLSCHEMA_VALIDATION`

    - ### Fields inherited from class org.apache.xerces.util.ParserConfigurationSettings

      `fFeatures, fParentSettings, fProperties, fRecognizedFeatures, fRecognizedProperties, PARSER_SETTINGS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SecureProcessingConfiguration()` Default constructor.
    `SecureProcessingConfiguration(SymbolTable symbolTable)` Constructs a parser configuration using the specified symbol table.
    `SecureProcessingConfiguration(SymbolTable symbolTable, org.apache.xerces.xni.grammars.XMLGrammarPool grammarPool)` Constructs a parser configuration using the specified symbol table and grammar pool.
    `SecureProcessingConfiguration(SymbolTable symbolTable, org.apache.xerces.xni.grammars.XMLGrammarPool grammarPool, org.apache.xerces.xni.parser.XMLComponentManager parentSettings)` Constructs a parser configuration using the specified symbol table, grammar pool, and parent settings.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `checkEntitySizeLimits(int sizeOfEntity, int delta, boolean isPE)`
    `protected void` | `configurePipeline()` Configures the XML 1.0 pipeline.
    `protected void` | `configureXML11Pipeline()` Configures the XML 1.1 pipeline.
    `java.lang.Object` | `getProperty(java.lang.String propertyId)` Returns the value of a property.
    `void` | `setProperty(java.lang.String propertyId, java.lang.Object value)` setProperty

    - ### Methods inherited from class org.apache.xerces.parsers.XIncludeAwareParserConfiguration

      `getFeature, setFeature`

    - ### Methods inherited from class org.apache.xerces.parsers.XML11Configuration

      `addCommonComponent, addComponent, addRecognizedParamsAndSetDefaults, addXML11Component, checkFeature, checkProperty, cleanup, getDocumentHandler, getDTDContentModelHandler, getDTDHandler, getEntityResolver, getErrorHandler, getLocale, parse, parse, reset, resetCommon, resetXML11, setDocumentHandler, setDTDContentModelHandler, setDTDHandler, setEntityResolver, setErrorHandler, setInputSource, setLocale`

    - ### Methods inherited from class org.apache.xerces.util.ParserConfigurationSettings

      `addRecognizedFeatures, addRecognizedProperties`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.xerces.xni.parser.XMLParserConfiguration

      `addRecognizedFeatures, addRecognizedProperties`

- - ### Field Detail

    - #### ENTITY_EXPANSION_LIMIT_SYSTEM_VALUE

          protected final int ENTITY_EXPANSION_LIMIT_SYSTEM_VALUE

    - #### MAX_OCCUR_LIMIT_SYSTEM_VALUE

          protected final int MAX_OCCUR_LIMIT_SYSTEM_VALUE

    - #### TOTAL_ENTITY_SIZE_LIMIT_SYSTEM_VALUE

          protected final int TOTAL_ENTITY_SIZE_LIMIT_SYSTEM_VALUE

    - #### MAX_GENERAL_ENTITY_SIZE_LIMIT_SYSTEM_VALUE

          protected final int MAX_GENERAL_ENTITY_SIZE_LIMIT_SYSTEM_VALUE

    - #### MAX_PARAMETER_ENTITY_SIZE_LIMIT_SYSTEM_VALUE

          protected final int MAX_PARAMETER_ENTITY_SIZE_LIMIT_SYSTEM_VALUE

    - #### RESOLVE_EXTERNAL_ENTITIES_SYSTEM_VALUE

          protected final boolean RESOLVE_EXTERNAL_ENTITIES_SYSTEM_VALUE

  - ### Constructor Detail

    - #### SecureProcessingConfiguration

          public SecureProcessingConfiguration()

      Default constructor.

    - #### SecureProcessingConfiguration

          public SecureProcessingConfiguration(SymbolTable symbolTable)

      Constructs a parser configuration using the specified symbol table.
      Parameters:
        `symbolTable` - The symbol table to use.

    - #### SecureProcessingConfiguration

          public SecureProcessingConfiguration(SymbolTable symbolTable,
                                       org.apache.xerces.xni.grammars.XMLGrammarPool grammarPool)

      Constructs a parser configuration using the specified symbol table and grammar pool.

      Parameters:
        `symbolTable` - The symbol table to use.
        `grammarPool` - The grammar pool to use.

    - #### SecureProcessingConfiguration

          public SecureProcessingConfiguration(SymbolTable symbolTable,
                                       org.apache.xerces.xni.grammars.XMLGrammarPool grammarPool,
                                       org.apache.xerces.xni.parser.XMLComponentManager parentSettings)

      Constructs a parser configuration using the specified symbol table, grammar pool, and parent settings.

      Parameters:
        `symbolTable` - The symbol table to use.
        `grammarPool` - The grammar pool to use.
        `parentSettings` - The parent settings.

  - ### Method Detail

    - #### checkEntitySizeLimits

          protected void checkEntitySizeLimits(int sizeOfEntity,
                                   int delta,
                                   boolean isPE)

    - #### getProperty

          public java.lang.Object getProperty(java.lang.String propertyId)
                                       throws org.apache.xerces.xni.parser.XMLConfigurationException

      Returns the value of a property.
      Specified by:
        `getProperty` in interface `org.apache.xerces.xni.parser.XMLComponentManager`
      Specified by:
        `getProperty` in interface `org.apache.xerces.xni.parser.XMLParserConfiguration`
      Overrides:
        `getProperty` in class `XML11Configuration`
      Parameters:
        `propertyId` - The property identifier.
      Returns:
        the value of the property
      Throws:
        `org.apache.xerces.xni.parser.XMLConfigurationException` - Thrown for configuration error. In general, components should only throw this exception if it is really a critical error.

    - #### setProperty

          public void setProperty(java.lang.String propertyId,
                         java.lang.Object value)
                           throws org.apache.xerces.xni.parser.XMLConfigurationException

      setProperty
      Specified by:
        `setProperty` in interface `org.apache.xerces.xni.parser.XMLParserConfiguration`
      Overrides:
        `setProperty` in class `XML11Configuration`
      Parameters:
        `propertyId` -
        `value` -
      Throws:
        `org.apache.xerces.xni.parser.XMLConfigurationException` - Thrown if there is a configuration error.

    - #### configurePipeline

          protected void configurePipeline()

      Configures the XML 1.0 pipeline.
      Overrides:
        `configurePipeline` in class `XIncludeAwareParserConfiguration`

    - #### configureXML11Pipeline

          protected void configureXML11Pipeline()

      Configures the XML 1.1 pipeline.
      Overrides:
        `configureXML11Pipeline` in class `XIncludeAwareParserConfiguration`

Copyright © 1999-2022 The Apache Software Foundation. All Rights Reserved.